﻿import mx.utils.Delegate
import flash.filters.GlowFilter

class Sun extends Events
{
	private var movingMC: MovieClip;
	
	function Sun( tl: MovieClip )
	{
		super( );
		
		init( tl );
	}
	
	private function init( tl: MovieClip )
	{
		var color:Number = 0xFF9933;
		var alpha:Number = .8;
		var blurX:Number = 35;
		var blurY:Number = 35;
		var strength:Number = 6;
		var quality:Number = 3;
		var inner:Boolean = false;
		var knockout:Boolean = false;		
		
		var glow: GlowFilter  = new GlowFilter( color, alpha, blurX, blurY, strength, quality, inner, knockout );		
		
		this.movingMC = tl.attachMovie( "Sun", "sun", tl.getNextHighestDepth( ), { _x:60, _y:60 } );
		
		var myFilters: Array = Array( this.movingMC.filters );
		//myFilters.push( this.blur );
		myFilters[ 0 ] = glow;
		this.movingMC.filters = myFilters;

		this.movingMC.onPress 			= Delegate.create( this, pressed );
		this.movingMC.onRelease 		= Delegate.create( this, released );
		this.movingMC.onReleaseOutside 	= Delegate.create( this, releasedOutside );
	}
	
	private function pressed( )
	{
		trace( "pressed" );
		this.movingMC.startDrag( );	
		
		//TODO. Aplicar efecto de blur
		
		dispatchEvent( { type: "onDragging" } );
	}
	
	private function released( )
	{
		this.movingMC.stopDrag( );
		
		//eliminar blur
		
		dispatchEvent( { type: "onDropped" } );
	}
	
	private function releasedOutside( )
	{
		this.movingMC.stopDrag( );
		
		//eliminar blur
		
		dispatchEvent( { type: "onDropped" } );
	}
	
	//Refactor para que devuelve un point
	public function getPosition( ): Object 
	{
		return { x: this.movingMC._x, y: this.movingMC._y };
	}
	
}